/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.6 Standard
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 01.11.2008
Author  : VLADIMIR
Company : MY HOME
Comments:


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#include <stdio.h>// sprintf

#define TWINT	7  //     TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN)
#define TWEA	6
#define TWSTA	5
#define TWSTO	4
#define TWEN	2
#define Start TWCR = ((1 << TWINT) | (1 << TWSTA) | (1 << TWEN))
#define Stop TWCR = ((1 << TWINT) | (1 << TWEN) | (1 << TWSTO))
#define Send TWCR = ((1 << TWINT) | (1 << TWEN)) // ACK ( )
#define Recieve TWCR = ((1 << TWINT) | (1 << TWEA) | (1 << TWEN)) // NACK ( )
#define Execute (!(TWCR & (1 << TWINT))) // TWINT(7-  TWCR) 


#asm
   .equ __lcd_port=0x1B ;PORTA      // Alphanumeric LCD Module functions
#endasm
#include <lcd.h>

void main(void)
{
unsigned char r;
char s[60];//  LCD
unsigned char rr[7];

ACSR=0x80;  // Analog Comparator  Off

TWBR=0x0C; // Bit Rate: 100,000 kHz
TWCR=0x04;  // 2 Wire Bus initialization

lcd_init(20);  // LCD module initialization

while (1)
      {
      Start; //  PCF8583
      while(Execute);
      TWDR=0xA0;     //  ( 0  0)
      Send;
      while(Execute);
      TWDR=0x00; //   PCF8583
      Send;
      while(Execute);
      Start;   // 
      while(Execute);
      TWDR=0xA1;   //   ( 0  1)
      Send;
      while(Execute);
      for(r=0;r<7;r++){ //  PCF8583( 0-7 , 8-15 )
      if(r<6)Recieve;   //  
      else
      Send;   //  ( ,   )
      while(Execute);
      rr[r]=TWDR;}     //        "rr"
      Stop;
      sprintf(s,"Time %X:%X:%X:%X",rr[4],rr[3],rr[2],rr[1]); // 
      lcd_gotoxy(1,0);
      lcd_puts(s);
      rr[6] = rr[6]&0x3F;
      sprintf(s,"Data %X:%X",rr[5],rr[6]);  // 
      lcd_gotoxy(4,1);
      lcd_puts(s);
      };
}
